#ifndef __DATAPROVIDER_H
#define __DATAPROVIDER_H

#include <string.h>
#include "Global.h"
#include "DEM.h"

class DataProvider 
{
public: 
  char urlRoot[256];
  int size;
  DEM *returnedDEM;
  
  URLDEM ***data; //the array of pointers to DEMs
  
  DataProvider(char *anURL, int aSize): size(aSize)
  {
    strcpy(urlRoot, anURL);
    NewMatrix(data, size, size, URLDEM*);

    int i, j;
    
    //temporary solution only!
    for(i=0; i<size; i++)
      for(j=0; j<size; j++) 
	if (!downloadDEM(i, j)) 
	  printf("Cannot load the file: %s%d%d", urlRoot, i, j);
  }
  
  ~DataProvider() 
  {
    DeleteMatrix(data);
  };
  

  int downloadDEM(int i, int j);
  int downloadTexture(char *url);

  DEM *getDEM(int xPos, int yPos, int dim);
  
  char *getTexture(int xPos, int yPos, int dim);
};

#endif
